%define name    safekeep
%define version 1.4.0
%define release 1
%define homedir %{_localstatedir}/lib/%{name}

Name:           %{name}
Version:        %{version}
Release:        %{release}%{?dist}
Summary:        The SafeKeep backup system

Group:          Applications/System
License:        GPLv2+
URL:            http://safekeep.sourceforge.net
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
# Now included in distributed documentation
#Source1:        README.Fedora
# Don't execute unless backup configurations exist
# Issue addressed upstream with 1.3.3
#Patch0:	safekeep-cron.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  xmlto, asciidoc > 6.0.3

%description
SafeKeep is a client/server backup system which enhances the
power of rdiff-backup with simple, centralized configuration.

%package common
Summary:        The SafeKeep backup system (common component)
Group:          Applications/System
Requires:       rdiff-backup
Requires:       python >= 2.3

%description common
SafeKeep is a client/server backup system which enhances the
power of rdiff-backup with simple, centralized configuration.

This is the common component of SafeKeep. It is shared in 
between the client/server components.

%package client
Summary:        The SafeKeep backup system (client component)
Group:          Applications/System
Requires:       openssh-server
Requires:       coreutils
Requires:       util-linux
Requires:       safekeep-common = %{version}-%{release}

%description client
SafeKeep is a client/server backup system which enhances the
power of rdiff-backup with simple, centralized configuration.

This is the client component of SafeKeep. It should be
installed on all hosts that need to be backed-up.

%package server
Summary:        The SafeKeep backup system (server component)
Group:          Applications/System
Requires(pre):  %{_sbindir}/useradd
Requires(pre):  %{_sbindir}/groupadd
Requires:       openssh, openssh-clients
Requires:       safekeep-common = %{version}-%{release}

%description server
SafeKeep is a client/server backup system which enhances the
power of rdiff-backup with simple, centralized configuration.

This is the server component of SafeKeep. It should be
installed on the server on which the data will be backed-up to.

%prep
%setup -q
#%patch0 -p1
rm -f *.orig

%build
make build

%install
rm -rf %{buildroot}
install -d -m 755 "%{buildroot}%{_sysconfdir}/safekeep/backup.d"
install -m 664 safekeep.conf "%{buildroot}%{_sysconfdir}/safekeep/"
install -d -m 755 "%{buildroot}%{_sysconfdir}/cron.daily"
install -m 755 safekeep.cron "%{buildroot}%{_sysconfdir}/cron.daily/safekeep"
install -d -m 755 "%{buildroot}%{_bindir}/"
install -m 755 safekeep "%{buildroot}%{_bindir}/"
install -d -m 755 "%{buildroot}%{_mandir}/man1/"
install -m 444 doc/safekeep.1 "%{buildroot}%{_mandir}/man1/"
install -d -m 755 "%{buildroot}%{_mandir}/man5/"
install -m 444 doc/safekeep.conf.5 "%{buildroot}%{_mandir}/man5/"
install -m 444 doc/safekeep.backup.5 "%{buildroot}%{_mandir}/man5/"
install -d -m 750 "%{buildroot}%{homedir}"
install -d -m 700 "%{buildroot}%{homedir}/.ssh"

%clean
rm -rf "%{buildroot}"

%pre server
%{_sbindir}/groupadd -f -r %{name}
id %{name} >/dev/null 2>&1 || \
%{_sbindir}/useradd -r -g %{name} -d %{homedir} -s /sbin/nologin \
  -c "Used by safekeep to run and store backups." %{name}

%files common
%defattr(-,root,root,-)
%{_bindir}/safekeep
%{_mandir}/man1/safekeep.1*
%doc AUTHORS COPYING LICENSE README TODO

%files client
%defattr(-,root,root,-)

%files server
%defattr(-,root,root,-)
%attr(750,%{name},%{name}) %dir %{homedir}
%attr(700,%{name},%{name}) %dir %{homedir}/.ssh
%dir %{_sysconfdir}/safekeep
%dir %{_sysconfdir}/safekeep/backup.d
%config(noreplace) %{_sysconfdir}/safekeep/safekeep.conf
%{_sysconfdir}/cron.daily/safekeep
%{_mandir}/man5/safekeep.conf.5*
%{_mandir}/man5/safekeep.backup.5*
%doc samples/

%changelog
* Sun Feb 12 2012 Frank Crawford <frank@crawford.emu.id.au> 1.4.0-1
  - Latest upstream release 

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sun Nov 27 2011 Frank Crawford <frank@crawford.emu.id.au> 1.3.3-1
  - Latest upstream release 
  - Dropped safekeep.cron patch as issue addressed up stream

* Sat May 08 2011 Frank Crawford <frank@crawford.emu.id.au> 1.3.2-2
  - Patch safekeep.cron to not run unless safekeep has been configured

* Sat Mar 12 2011 Frank Crawford <frank@crawford.emu.id.au> 1.3.2-1
  - Latest upstream release 

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Dec 14 2009 Jef Spaleta <jspaleta AT fedoraproject DOT org> 1.2.1-1
  - Latest upstream release 

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Jan 3 2009 Jef Spaleta <jspaleta AT fedoraproject DOT org> 1.0.5-1
  - Latest upstream release 

* Tue Jul 1 2008 Jef Spaleta <jspaleta AT fedoraproject DOT org> 1.0.4-1
  - Latest upstream release 

* Fri Oct 19 2007 Jef Spaleta <jspaleta@gmail.com> 1.0.3-2
  - Added README.Fedora with explanation of client subpackaging.

* Fri Oct 19 2007 Dimi Paun <dimi@lattica.com> 1.0.3-1
  - Clarify licensing in lite of the new GPLv3 license;
  - New --force option to handle unexpected problems with the data repository;
  - Better logging and status handling when we invoke external commands
  - Clearer backup status on job end.
  - A small packaging bug got fixes.

* Fri Sep 7 2007 Dimi Paun <dimi@lattica.com> 1.0.2-1
  - Add missing buildroot removal in install section (Jeff Spaleta)
  - Remove references to PACKAGE_VERSION, follow the Fedora 
    guidelines closer.
  - Provide default attr for all packages.
  - Clarify the licensing in .rpm package.
  - We don't need to include AUTHORS COPYING LICENSE multiple times, 
    keeping them in -common is enough.
  - More acceptable SF link.

* Sun Jun 17 2007 Dimi Paun <dimi@lattica.com> 1.0.1-1
  - The safekeep user no longer requires a working shell
  - Add support for Fedora 7 to the testing script
  - Packaging improvements for integration into Fedora
  - Remove the old configuration migration scripts
  - Do not package the testing script, it's used only during development

* Wed May 16 2007 Dimi Paun <dimi@lattica.com> 1.0.0-1
  - Small documentation inprovements.

* Fri Apr 27 2007 Dimi Paun <dimi@lattica.com> 0.9.3-1
  - Use /bin/bash as the shell for the safekeep system account;
  - Invoke rdiff-backup with --force when trimming histroy;
  - A few small logging bugs got fixed;
  - Small documentation tweaks.

* Tue Mar 13 2007 Dimi Paun <dimi@lattica.com> 0.9.2-1
  - Client configuration files have been moved to 
    /etc/safekeep/backup.d, and have the extension '.backup';
  - A new global configuration file has been added in 
    /etc/safekeep/safekeep.conf;
  - A number of command line options have been deprecated;
    (-e/--email, -s/--smtp), and moved to the global configuration.
  - SafeKeep now knows of the user under which the backup will execute,
    making it possible to better deploy keys, avoid the need to invoke
    safekeep(1) via sudo(8), and execute the backup as root if need be;
  - Relative paths now have more intuitive behaviour;
  - Some documentation improvements;
  - Automatic migration of old configuration to the new format;
  - A CRITICAL (e.g. data loss) race has been fixed.

* Mon Feb 12 2007 Dimi Paun <dimi@lattica.com> 0.9.1-1
  - Lots of documentation improvements;
  - Prepare the RPMs for Fedora acceptance (Jef Spaleta);
  - Automatic creation of data store directory;
  - A few bug fixes.

* Thu Feb  1 2007 Dimi Paun <dimi@lattica.com> 0.9.0-1
  - Initial release
